Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/albedo.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/albedo.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/albedo.F90	(revision 2620)
@@ -47,7 +47,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -66,6 +65,5 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_use, wrk_release, llwrk_use, llwrk_release
-      USE wrk_nemo, ONLY: llwrk_3d_1 
-      USE wrk_nemo, ONLY: wrk_3d_6, wrk_3d_7
+      USE wrk_nemo, ONLY: wrk_3d_6, wrk_3d_7    ! 3D workspace
       !!
       REAL(wp), INTENT(in   ), DIMENSION(:,:,:) ::   pt_ice      !  ice surface temperature (Kelvin)
@@ -86,5 +84,4 @@
       REAL(wp) ::   zihsc2        ! = 1 hsn >= c2 ; = 0 hsn < c2
       !!
-      LOGICAL,  POINTER, DIMENSION(:,:,:) ::   llmask    ! Pointer to sub-array of workspace array
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zalbfz    ! = rn_alphdi for freezing ice ; = rn_albice for melting ice
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zficeth   !  function of ice thickness
@@ -93,18 +90,10 @@
       ijpl = SIZE( pt_ice, 3 )                     ! number of ice categories
 
-      IF( (.not. llwrk_use(3,1)) .OR. (.not. wrk_use(3, 6,7)) )THEN
-         CALL ctl_stop('albedo_ice: requested workspace arrays are unavailable.')
-         RETURN
-      ELSE IF(ijpl > jpk)THEN
-         ! 3D workspace arrays have extent jpk in 3rd dimension - check that 
-         ! ijpl doesn't exceed it.
-         CALL ctl_stop('albedo_ice: 3rd dimension of standard workspace arrays too small for them to be used here.')
-         RETURN
-      ELSE
-         ! Associate pointers with sub-arrays of workspace arrays
-         llmask  => llwrk_3d_1(:,:,1:ijpl)
-         zalbfz  =>   wrk_3d_6(:,:,1:ijpl)
-         zficeth =>   wrk_3d_7(:,:,1:ijpl)
-      END IF
+      IF( (.not. llwrk_use(3,1)) .OR. (.not. wrk_use(3, 6,7)) ) THEN
+         CALL ctl_stop('albedo_ice: requested workspace arrays are unavailable')   ;   RETURN
+      ENDIF
+      ! Associate pointers with sub-arrays of workspace arrays
+      zalbfz  =>   wrk_3d_6(:,:,1:ijpl)
+      zficeth =>   wrk_3d_7(:,:,1:ijpl)
 
       IF( albd_init == 0 )   CALL albedo_init      ! initialization 
@@ -113,27 +102,36 @@
       !  Computation of  zficeth
       !---------------------------
-      llmask(:,:,1:ijpl) = ( ph_snw == 0.e0 ) .AND. ( pt_ice >= rt0_ice )
       ! ice free of snow and melts
-      WHERE( llmask(:,:,1:ijpl) )   ;   zalbfz = rn_albice
-      ELSEWHERE                     ;   zalbfz = rn_alphdi
+      WHERE     ( ph_snw == 0._wp .AND. pt_ice >= rt0_ice )   ;   zalbfz(:,:,:) = rn_albice
+      ELSE WHERE                                              ;   zalbfz(:,:,:) = rn_alphdi
+      END  WHERE
+
+      WHERE     ( 1.5  < ph_ice                     )  ;  zficeth = zalbfz
+      ELSE WHERE( 1.0  < ph_ice .AND. ph_ice <= 1.5 )  ;  zficeth = 0.472  + 2.0 * ( zalbfz - 0.472 ) * ( ph_ice - 1.0 )
+      ELSE WHERE( 0.05 < ph_ice .AND. ph_ice <= 1.0 )  ;  zficeth = 0.2467 + 0.7049 * ph_ice              &
+         &                                                                 - 0.8608 * ph_ice * ph_ice     &
+         &                                                                 + 0.3812 * ph_ice * ph_ice * ph_ice
+      ELSE WHERE                                       ;  zficeth = 0.1    + 3.6    * ph_ice
       END WHERE
 
-      DO jl = 1, ijpl
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               IF( ph_ice(ji,jj,jl) > 1.5 ) THEN
-                  zficeth(ji,jj,jl) = zalbfz(ji,jj,jl)
-               ELSEIF( ph_ice(ji,jj,jl) > 1.0  .AND. ph_ice(ji,jj,jl) <= 1.5 ) THEN
-                  zficeth(ji,jj,jl) = 0.472 + 2.0 * ( zalbfz(ji,jj,jl) - 0.472 ) * ( ph_ice(ji,jj,jl) - 1.0 )
-               ELSEIF( ph_ice(ji,jj,jl) > 0.05 .AND. ph_ice(ji,jj,jl) <= 1.0 ) THEN
-                  zficeth(ji,jj,jl) = 0.2467 + 0.7049 * ph_ice(ji,jj,jl)                               &
-                     &                    - 0.8608 * ph_ice(ji,jj,jl) * ph_ice(ji,jj,jl)                 &
-                     &                    + 0.3812 * ph_ice(ji,jj,jl) * ph_ice(ji,jj,jl) * ph_ice (ji,jj,jl)
-               ELSE
-                  zficeth(ji,jj,jl) = 0.1 + 3.6 * ph_ice(ji,jj,jl) 
-               ENDIF
-            END DO
-         END DO
-      END DO
+!!gm old code
+!      DO jl = 1, ijpl
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               IF( ph_ice(ji,jj,jl) > 1.5 ) THEN
+!                  zficeth(ji,jj,jl) = zalbfz(ji,jj,jl)
+!               ELSEIF( ph_ice(ji,jj,jl) > 1.0  .AND. ph_ice(ji,jj,jl) <= 1.5 ) THEN
+!                  zficeth(ji,jj,jl) = 0.472 + 2.0 * ( zalbfz(ji,jj,jl) - 0.472 ) * ( ph_ice(ji,jj,jl) - 1.0 )
+!               ELSEIF( ph_ice(ji,jj,jl) > 0.05 .AND. ph_ice(ji,jj,jl) <= 1.0 ) THEN
+!                  zficeth(ji,jj,jl) = 0.2467 + 0.7049 * ph_ice(ji,jj,jl)                               &
+!                     &                    - 0.8608 * ph_ice(ji,jj,jl) * ph_ice(ji,jj,jl)                 &
+!                     &                    + 0.3812 * ph_ice(ji,jj,jl) * ph_ice(ji,jj,jl) * ph_ice (ji,jj,jl)
+!               ELSE
+!                  zficeth(ji,jj,jl) = 0.1 + 3.6 * ph_ice(ji,jj,jl) 
+!               ENDIF
+!            END DO
+!         END DO
+!      END DO
+!!gm end old code
       
       !----------------------------------------------- 
@@ -174,7 +172,5 @@
       pa_ice_os(:,:,:) = pa_ice_cs(:,:,:) + rn_cloud       ! Oberhuber correction
       !
-      IF( (.not. llwrk_release(3, 1)) .OR. (.not. wrk_release(3, 6,7)) )THEN
-         CALL ctl_stop('albedo_ice: failed to release workspace arrays.')
-      END IF
+      IF( .not. wrk_release(3, 6,7) )   CALL ctl_stop('albedo_ice: failed to release workspace arrays')
       !
    END SUBROUTINE albedo_ice
@@ -186,6 +182,4 @@
       !! 
       !! ** Purpose :   Computation of the albedo of the ocean
-      !!
-      !! ** Method  :   ....
       !!----------------------------------------------------------------------
       REAL(wp), DIMENSION(:,:), INTENT(out) ::   pa_oce_os   !  albedo of ocean under overcast sky
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 2620)
@@ -6,6 +6,6 @@
    !!=====================================================================
    !! History :   
-   !!   9.0  !  04-06  (R. Redler, NEC Laboratories Europe, St Augustin, Germany) Original code
-   !!   " "  !  04-11  (R. Redler, NEC Laboratories Europe; N. Keenlyside, W. Park, IFM-GEOMAR, Kiel, Germany) revision
+   !!   9.0  !  04-06  (R. Redler, NEC Laboratories Europe, Germany) Original code
+   !!   " "  !  04-11  (R. Redler, NEC Laboratories Europe; N. Keenlyside, W. Park, IFM-GEOMAR, Germany) revision
    !!   " "  !  04-11  (V. Gayler, MPI M&D) Grid writing
    !!   " "  !  05-08  (R. Redler, W. Park) frld initialization, paral(2) revision
@@ -17,5 +17,4 @@
    !!----------------------------------------------------------------------
    !!   'key_oasis3'                    coupled Ocean/Atmosphere via OASIS3
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   cpl_prism_init     : initialization of coupled mode communication
@@ -34,10 +33,18 @@
    USE in_out_manager               ! I/O manager
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+
    IMPLICIT NONE
    PRIVATE
-!
-   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .TRUE.   ! coupled flag
-   INTEGER, PUBLIC            :: OASIS_Rcv  = 1    ! return code if received field
-   INTEGER, PUBLIC            :: OASIS_idle = 0    ! return code if nothing done by oasis
+
+   PUBLIC cpl_prism_init
+   PUBLIC cpl_prism_define
+   PUBLIC cpl_prism_snd
+   PUBLIC cpl_prism_rcv
+   PUBLIC cpl_prism_freq
+   PUBLIC cpl_prism_finalize
+
+   LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .TRUE.   !: coupled flag
+   INTEGER, PUBLIC            :: OASIS_Rcv  = 1    !: return code if received field
+   INTEGER, PUBLIC            :: OASIS_idle = 0    !: return code if nothing done by oasis
    INTEGER                    :: ncomp_id          ! id returned by prism_init_comp
    INTEGER                    :: nerror            ! return error code
@@ -45,5 +52,5 @@
    INTEGER, PARAMETER :: nmaxfld=40    ! Maximum number of coupling fields
    
-   TYPE, PUBLIC ::   FLD_CPL            ! Type for coupling field information
+   TYPE, PUBLIC ::   FLD_CPL            !: Type for coupling field information
       LOGICAL            ::   laction   ! To be coupled or not
       CHARACTER(len = 8) ::   clname    ! Name of the coupling field   
@@ -53,26 +60,16 @@
    END TYPE FLD_CPL
 
-   TYPE(FLD_CPL), DIMENSION(nmaxfld), PUBLIC :: srcv, ssnd   ! Coupling fields
+   TYPE(FLD_CPL), DIMENSION(nmaxfld), PUBLIC :: srcv, ssnd   !: Coupling fields
 
    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: exfld  ! Temporary buffer for receiving
-
-   !! Routine accessibility
-   PUBLIC cpl_prism_init
-   PUBLIC cpl_prism_define
-   PUBLIC cpl_prism_snd
-   PUBLIC cpl_prism_rcv
-   PUBLIC cpl_prism_freq
-   PUBLIC cpl_prism_finalize
 
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE cpl_prism_init (kl_comm) 
-
+   SUBROUTINE cpl_prism_init( kl_comm )
       !!-------------------------------------------------------------------
       !!             ***  ROUTINE cpl_prism_init  ***
@@ -83,5 +80,5 @@
       !! ** Method  :   OASIS3 MPI communication 
       !!--------------------------------------------------------------------
-      INTEGER, INTENT(   OUT )   :: kl_comm       ! local communicator of the model
+      INTEGER, INTENT(out) ::   kl_comm   ! local communicator of the model
       !!--------------------------------------------------------------------
 
@@ -103,10 +100,9 @@
       IF ( nerror /= PRISM_Ok ) &
          CALL prism_abort_proto (ncomp_id, 'cpl_prism_init','Failure in prism_get_localcomm_proto' )
-
+      !
    END SUBROUTINE cpl_prism_init
 
 
-   SUBROUTINE cpl_prism_define (krcv, ksnd)
-
+   SUBROUTINE cpl_prism_define( krcv, ksnd )
       !!-------------------------------------------------------------------
       !!             ***  ROUTINE cpl_prism_define  ***
@@ -117,11 +113,10 @@
       !! ** Method  :   OASIS3 MPI communication 
       !!--------------------------------------------------------------------
-      INTEGER, INTENT( IN    )   :: krcv, ksnd     ! Number of received and sent coupling fields
-      !
-      INTEGER                    :: id_part
-      INTEGER                    :: paral(5)       ! OASIS3 box partition
-      INTEGER                    :: ishape(2,2)    ! shape of arrays passed to PSMILe
-      INTEGER                    :: ji             ! local loop indicees
-      !!
+      INTEGER, INTENT(in) ::   krcv, ksnd     ! Number of received and sent coupling fields
+      !
+      INTEGER :: id_part
+      INTEGER :: paral(5)       ! OASIS3 box partition
+      INTEGER :: ishape(2,2)    ! shape of arrays passed to PSMILe
+      INTEGER :: ji             ! local loop indicees
       !!--------------------------------------------------------------------
 
@@ -142,7 +137,6 @@
       !
       ALLOCATE(exfld(nlei-nldi+1, nlej-nldj+1), stat = nerror)
-      IF (nerror > 0) THEN
-         CALL prism_abort_proto ( ncomp_id, 'cpl_prism_define', 'Failure in allocating exfld')
-         RETURN
+      IF( nerror > 0 ) THEN
+         CALL prism_abort_proto ( ncomp_id, 'cpl_prism_define', 'Failure in allocating exfld')   ;   RETURN
       ENDIF
       !
@@ -197,11 +191,10 @@
       
       CALL prism_enddef_proto(nerror)
-      IF ( nerror /= PRISM_Ok )   CALL prism_abort_proto ( ncomp_id, 'cpl_prism_define', 'Failure in prism_enddef')
-      
+      IF( nerror /= PRISM_Ok )   CALL prism_abort_proto ( ncomp_id, 'cpl_prism_define', 'Failure in prism_enddef')
+      !
    END SUBROUTINE cpl_prism_define
    
    
    SUBROUTINE cpl_prism_snd( kid, kstep, pdata, kinfo )
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_snd  ***
@@ -210,12 +203,8 @@
       !!      like sst or ice cover to the coupler or remote application.
       !!----------------------------------------------------------------------
-      !! * Arguments
-      !!
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable index in the array
-      INTEGER,                      INTENT(   OUT )   :: kinfo     ! OASIS3 info argument
-      INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( IN    )   :: pdata
-      !!
-      !!
+      INTEGER                 , INTENT(in   ) ::   kid       ! variable index in the array
+      INTEGER                 , INTENT(  out) ::   kinfo     ! OASIS3 info argument
+      INTEGER                 , INTENT(in   ) ::   kstep     ! ocean time-step in seconds
+      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   pdata
       !!--------------------------------------------------------------------
       !
@@ -236,11 +225,11 @@
             WRITE(numout,*) '     -     Sum value is ', SUM(pdata)
             WRITE(numout,*) '****************'
-        ENDIF
-     ENDIF
+         ENDIF
+      ENDIF
+      !
     END SUBROUTINE cpl_prism_snd
 
 
    SUBROUTINE cpl_prism_rcv( kid, kstep, pdata, kinfo )
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_rcv  ***
@@ -249,8 +238,8 @@
       !!      like stresses and fluxes from the coupler or remote application.
       !!----------------------------------------------------------------------
-      INTEGER,                      INTENT( IN    )   :: kid       ! variable index in the array
-      INTEGER,                      INTENT( IN    )   :: kstep     ! ocean time-step in seconds
-      REAL(wp),     DIMENSION(:,:), INTENT( INOUT )   :: pdata     ! IN to keep the value if nothing is done
-      INTEGER,                      INTENT(   OUT )   :: kinfo     ! OASIS3 info argument
+      INTEGER                 , INTENT(in   ) ::   kid       ! variable index in the array
+      INTEGER                 , INTENT(in   ) ::   kstep     ! ocean time-step in seconds
+      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pdata     ! IN to keep the value if nothing is done
+      INTEGER                 , INTENT(  out) ::   kinfo     ! OASIS3 info argument
       !!
       LOGICAL                :: llaction
@@ -291,10 +280,9 @@
          kinfo = OASIS_idle     
       ENDIF
-
+      !
    END SUBROUTINE cpl_prism_rcv
 
 
    FUNCTION cpl_prism_freq( kid )  
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_freq  ***
@@ -304,11 +292,11 @@
       INTEGER,INTENT( IN )   :: kid              ! variable index 
       INTEGER                :: cpl_prism_freq   ! coupling frequency
+      !!----------------------------------------------------------------------
       cpl_prism_freq = ig_def_freq( kid )
-
+      !
    END FUNCTION cpl_prism_freq
 
 
    SUBROUTINE cpl_prism_finalize
-
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_finalize  ***
@@ -318,16 +306,13 @@
       !!      MPI communication.
       !!----------------------------------------------------------------------
-
+      !
       DEALLOCATE(exfld)
       CALL prism_terminate_proto ( nerror )         
-
+      !
    END SUBROUTINE cpl_prism_finalize
 
 #else
-
-   !!----------------------------------------------------------------------
-   !!   Default case                                Forced Ocean/Atmosphere
-   !!----------------------------------------------------------------------
-   !!   Empty module
+   !!----------------------------------------------------------------------
+   !!   Default case          Dummy module          Forced Ocean/Atmosphere
    !!----------------------------------------------------------------------
    USE in_out_manager               ! I/O manager
@@ -335,18 +320,15 @@
    PUBLIC cpl_prism_init
    PUBLIC cpl_prism_finalize
-
 CONTAINS
-
    SUBROUTINE cpl_prism_init (kl_comm) 
-      INTEGER, INTENT(   OUT )   :: kl_comm       ! local communicator of the model
+      INTEGER, INTENT(out)   :: kl_comm       ! local communicator of the model
       kl_comm = -1
       WRITE(numout,*) 'cpl_prism_init: Error you sould not be there...'
    END SUBROUTINE cpl_prism_init
-
    SUBROUTINE cpl_prism_finalize
       WRITE(numout,*) 'cpl_prism_finalize: Error you sould not be there...'
    END SUBROUTINE cpl_prism_finalize
-
 #endif
 
+   !!=====================================================================
 END MODULE cpl_oasis3
